=== debian/changelog ===
pgrouting (4.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 08 Nov 2025 05:29:24 +0100
