=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <fladi@debian.org>
Section: misc
Priority: optional
Build-Depends: architecture-is-64-bit <!pkg.postgresql.32-bit>,
               cmake (>= 3.2),
               debhelper-compat (= 13),
               libboost-graph-dev,
               postgis,
               postgresql-server-dev-all,
               rdfind,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pgrouting
Vcs-Git: https://salsa.debian.org/debian-gis-team/pgrouting.git
Homepage: https://www.pgrouting.org

Package: postgresql-18-pgrouting
Architecture: any
Depends: postgresql-18-pgrouting-scripts (>= ${source:Version}),
         postgresql-18,
         postgresql-18-postgis,
         postgresql-18-postgis-scripts,
         ${postgresql:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 18.

Package: postgresql-18-pgrouting-scripts
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the SQL scripts for installing pgRouting, and for
 upgrading from earlier pgRouting versions.
 .
 This package supports PostgreSQL 18.

Package: postgresql-pgrouting
Architecture: any
Section: metapackages
Depends: postgresql-pgrouting-scripts,
         postgresql-18-pgrouting,
         ${misc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS - Metapackage
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This metapackage depends on the PgRouting package for PostgreSQL 18.

Package: postgresql-pgrouting-scripts
Architecture: all
Multi-Arch: foreign
Section: metapackages
Depends: postgresql-18-pgrouting-scripts,
         ${misc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS - SQL scripts metapackage
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This metapackage depends on the PgRouting scripts package for
 PostgreSQL 18.
