=== doxygen/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,6 @@
+# This file is part of the pgRouting project.
+# Copyright (c) 2016-2026 pgRouting developers
+# License: GPL-2 See https://github.com/pgRouting/pgrouting/blob/main/LICENSE
 # Main changes
 # developers is build by default unless other wise stated
