=== debian/changelog ===
pgrouting (4.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Use debrebuild instead of reprotest.
  * Drop Priority: optional, default since dpkg 1.22.13.
  * Bump Standards-Version to 4.7.3, changes: priority.
  * Update copyright file.
  * Refresh patches.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 02 Feb 2026 07:07:44 +0100
