=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Michael Fladischer <fladi@debian.org>
 Section: misc
-Priority: optional
 Build-Depends: architecture-is-64-bit <!pkg.postgresql.32-bit>,
                cmake (>= 3.2),
                debhelper-compat (= 13),
@@ -10,7 +9,7 @@
                postgis,
                postgresql-server-dev-all,
                rdfind,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/pgrouting
 Vcs-Git: https://salsa.debian.org/debian-gis-team/pgrouting.git
 Homepage: https://www.pgrouting.org
